﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace GridMaximizer
{
  public partial class MainPage : UserControl
  {
    public MainPage()
    {
      InitializeComponent();
    }

    private void Click_MaxRest(object sender, RoutedEventArgs e)
    {
      ToggleMaximized();
    }

    public void ToggleMaximized()
    {
      if (_maximized)
        Restore();
      else
        Maximize();

      _maximized = !_maximized;
    }

    bool _maximized;

    void Maximize()
    {
      const int zero = 15;  // set to non-zero for demonstration purposes only

      LayoutRoot.ColumnDefinitions[0].Width = new GridLength(zero, GridUnitType.Pixel);
      LayoutRoot.ColumnDefinitions[1].Width = new GridLength(1, GridUnitType.Star);
      LayoutRoot.ColumnDefinitions[2].Width = new GridLength(zero, GridUnitType.Pixel);

      InnerLayout.RowDefinitions[0].Height = new GridLength(zero, GridUnitType.Pixel);
      InnerLayout.RowDefinitions[1].Height = new GridLength(1, GridUnitType.Star);
      InnerLayout.RowDefinitions[2].Height = new GridLength(zero, GridUnitType.Pixel);
      InnerLayout.ColumnDefinitions[0].Width = new GridLength(zero, GridUnitType.Pixel);
      InnerLayout.ColumnDefinitions[1].Width = new GridLength(1, GridUnitType.Star);
    }

    void Restore()
    {
      LayoutRoot.ColumnDefinitions[0].Width = new GridLength(1, GridUnitType.Star);
      LayoutRoot.ColumnDefinitions[1].Width = new GridLength(700, GridUnitType.Pixel);
      LayoutRoot.ColumnDefinitions[2].Width = new GridLength(1, GridUnitType.Star);

      InnerLayout.RowDefinitions[0].Height = new GridLength(100, GridUnitType.Pixel);
      InnerLayout.RowDefinitions[1].Height = new GridLength(1, GridUnitType.Star);
      InnerLayout.RowDefinitions[2].Height = new GridLength(30, GridUnitType.Pixel);
      InnerLayout.ColumnDefinitions[0].Width = new GridLength(180, GridUnitType.Pixel);
      InnerLayout.ColumnDefinitions[1].Width = new GridLength(1, GridUnitType.Star);
    }
  }
}
